//
//  TCCFCloudFeedback.m
//  TCCloudFeedback
//
//  Created by jryw on 15-3-4.
//  Copyright (c) 2015年 com.tencent. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>
#import <objc/runtime.h>

#import "TCCFCloudFeedback.h"
#import "UIAlertView+TCFBBlocks.h"

#define ALERT_TITLE_STR "云反馈提示"
#define ALERT_MESSAGE_STR "反馈功能需要安装手机QQ才可以使用，现在去下载安装。"
#define ALERT_BUTTON_OK_STR "确定"
#define ALERT_BUTTON_CANCEL_STR "取消"

@implementation TCCFCloudFeedback

+ (bool) wakeFeedbackForApp: (NSString *)appId
                    version: (NSString *)appVer
             viewController: (UIViewController *) viewController {
    if(appId == nil || appVer == nil) {
        return false;
    }
    
    return [[[TCCFCloudFeedback alloc] init] tryFeedback: appId version: appVer viewController: viewController];
}

- (bool) tryFeedback: (NSString *)appId
             version: (NSString *)appVer
      viewController: (UIViewController *) viewController {
    NSString *urlstr = [[NSString alloc] initWithString:
                        [NSString stringWithFormat:@"http://ping.huatuo.qq.com/feedback.html?appid=%s&appVer=%s",
                         [appId cStringUsingEncoding: NSUTF8StringEncoding],
                         [appVer cStringUsingEncoding: NSUTF8StringEncoding]]];
    NSData *urldata = [urlstr dataUsingEncoding: NSUTF8StringEncoding];
    NSString *urlbase64 = [urldata base64EncodedStringWithOptions: NSDataBase64EncodingEndLineWithLineFeed];
    NSMutableString *jumpurl = [[NSMutableString alloc] initWithString:@"mqqapi://forward/url?src_type=web&version=1&url_prefix="];
    [jumpurl appendString:urlbase64];
    NSURL *nsurl = [[NSURL alloc] initWithString: jumpurl];
    UIApplication *app = [UIApplication sharedApplication];
    
    BOOL canopen = [app canOpenURL: nsurl];
    if(canopen) {
        [app openURL: nsurl];
    }
    else {
        if (objc_getClass("UIAlertController") != nil) {
        //if (false) {
            NSLog(@"Notify user to downlod QQ.");
            UIAlertController *alert = [UIAlertController
                                         alertControllerWithTitle:@ALERT_TITLE_STR
                                         message:@ALERT_MESSAGE_STR
                                         preferredStyle:UIAlertControllerStyleAlert];
            UIAlertAction *okAction = [UIAlertAction
                                       actionWithTitle:@ALERT_BUTTON_OK_STR
                                       style:UIAlertActionStyleDefault
                                       handler:^(UIAlertAction *action) {
                                           [self downloadApp];
            }];
            UIAlertAction *cancelAction = [UIAlertAction
                                           actionWithTitle:@ALERT_BUTTON_CANCEL_STR
                                           style:UIAlertActionStyleCancel
                                           handler:nil];
            [alert addAction:cancelAction];
            [alert addAction:okAction];
            [viewController presentViewController:alert animated:YES completion:nil];
        }
        else {
            NSLog(@"Use AV to notify user to downlod QQ.");
            UIAlertView *alertView = [[UIAlertView alloc]
                                      initWithTitle:@ALERT_TITLE_STR
                                      message:@ALERT_MESSAGE_STR
                                      cancelButtonItem:[TCFBAVButtonItem itemWithLabel:@ALERT_BUTTON_CANCEL_STR action:^{
                                                           //NSLog(@ALERT_BUTTON_CANCEL_STR);
                                                       }]
                                      otherButtonItems:[TCFBAVButtonItem itemWithLabel:@ALERT_BUTTON_OK_STR action:^{
                                                           //NSLog(@ALERT_BUTTON_OK_STR);
                                                           [self downloadApp];
                                                       }],
                                      nil];
            [alertView show];
        }
    }
    
    return true;
}

- (void) downloadApp {
    NSURL *nsurl = [[NSURL alloc] initWithString: @"http://im.qq.com/download"];
    UIApplication *app = [UIApplication sharedApplication];
    [app openURL: nsurl];
}

@end